#include "sather.h"

/* Layouts */

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID immutable_part;
 } *SFILE_ID_boxed;

typedef struct AM_VOID_CONST_struct {/* layout for AM_VOID_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source1;
 } *AM_VOID_CONST;

typedef struct FLISTA725283029_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTA725283029;

#include "tags.h"

/* Globals */


/* Function declarations */


extern RETURNED_CONST BOOL (**dTP_is1334578382)(dTP);
AM_VOID_CONST AM_VOI1734446450(AM_VOID_CONST);
BOOL AM_VOI1214668736(AM_VOID_CONST);
BOOL AM_VOI2144357369(AM_VOID_CONST, OB);
FLISTA725283029 AM_VOI402497764(AM_VOID_CONST);
INT AM_VOI822416442(AM_VOID_CONST);
SFILE_ID AM_VOI405249940(AM_VOID_CONST);
dTP AM_VOI984518984(AM_VOID_CONST);

/* Bound rout stubs decls */


/* Bound iter stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




#undef IS_ITER
#define IS_ITER 0

AM_VOID_CONST AM_VOI1734446450(AM_VOID_CONST self) {
 AM_VOID_CONST ret_val;
 ret_val = self;
 return ret_val;
}


#undef IS_ITER
#define IS_ITER 0

BOOL AM_VOI1214668736(AM_VOID_CONST self) {
 BOOL ret_val = BOOL_zero;
 AM_VOID_CONST tp_self;
 dTP ret_val1;
 dTP L1;
 tp_self = self;
 ret_val1 = ATTR(tp_self,tp_at);
 L1 = ret_val1;
 ret_val = (*dTP_is1334578382[TAG(L1)])(L1);
 return ret_val;
}


#undef IS_ITER
#define IS_ITER 0

BOOL AM_VOI2144357369(AM_VOID_CONST self, OB a) {
 BOOL ret_val = BOOL_zero;
 if (a==NULL) {
  goto other145;
 } else
 switch (TAG(a)) {
  case AM_VOID_CONST_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
  other145: ;
   ret_val = FALSE;
   return ret_val;
 }
}


#undef IS_ITER
#define IS_ITER 0

FLISTA725283029 AM_VOI402497764(AM_VOID_CONST self) {
 FLISTA725283029 ret_val;
 ret_val = ((FLISTA725283029) NULL);
 return ret_val;
}


#undef IS_ITER
#define IS_ITER 0

INT AM_VOI822416442(AM_VOID_CONST self) {
 INT ret_val = INT_zero;
 ret_val = 12648273;
 return ret_val;
}


#undef IS_ITER
#define IS_ITER 0

SFILE_ID AM_VOI405249940(AM_VOID_CONST self) {
 return ATTR(self,source1);
}


#undef IS_ITER
#define IS_ITER 0

dTP AM_VOI984518984(AM_VOID_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}
